<?php // -*-php-*-
rcs_id('$Id: SyntaxHighlighter.php,v 1.12 2003/01/18 21:41:02 alecthomas Exp $');
/**
 Copyright 1999, 2000, 2001, 2002 $ThePhpWikiProgrammingTeam

 This file is part of PhpWiki.

 PhpWiki is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 PhpWiki is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with PhpWiki; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
	The SyntaxHighlighter plugin passes all its arguments through a C++ 
	highlighter called "highlight" (available at http://www.andre-simon.de/).

	The very first token must be the language in which to highlight.

	eg.

		<?plugin SyntaxHighlighter c
		#include <stdio.h>

		int main() {
			printf("Lalala\n");
		}
		?>

	I did not use beautifier, because it used up more than 8M of memory on
	my system and PHP killed it. I'm not sure whether this is a problem
	with my integration, or with beautifier itself.
*/
class WikiPlugin_SyntaxHighlighter
extends WikiPlugin
{
    // Five required functions in a WikiPlugin.

    function getName () {
        return _("SyntaxHighlighter");
    }

    function getDescription () {
        return _("Source code syntax highlighter (via http://www.andre-simon.de)");

    }

	function managesValidators() {
		return true;
	}

    function getVersion() {
        return preg_replace("/[Revision: $]/", '',
                            "\$Revision: 1.0 $");
    }

	function getDefaultArguments() {
		return array(
			'language' => null,
			'number' => 0,
			'wrap' => 0,
			);
					
	}

    function run($dbi, $argstr, $request) {
		// Get arguments from first line
		if (preg_match('/^(.*?[\n\r]+)/s', $argstr, $matches)) {
			extract($this->getArgs($matches[1]));
			$code = substr($argstr, strlen($matches[1]));
		} else
			$code = $argstr;

		if (empty($language)) return $this->error(_("Syntax language not specified)"));

		if (!empty($code)) {
			$descriptorspec = array(
				0 => array("pipe", "r"),
				1 => array("pipe", "w"),
			);
			$args = "";
			if ($number != 0) $args .= " -l";
			if ($wrap != 0) $args .= " -V";

			if (is_resource($highlight = proc_open("highlight$args -I -S $language -X -f", $descriptorspec, $pipes))) {
				fwrite($pipes[0], $code);
				fclose($pipes[0]);
				$code = "";
				while (!feof($pipes[1]))
					$code .= fgets($pipes[1]);
				fclose($pipes[1]);
				proc_close($highlight);
			}
			return HTML::raw('<pre class="tightenable top bottom">' . $code . "</pre>");
		}
    }
};

// For emacs users
// Local Variables:
// mode: php
// tab-width: 8
// c-basic-offset: 4
// c-hanging-comment-ender-p: nil
// indent-tabs-mode: nil
// End:
?>
